SystemOrganization addCategory: #'Aeropuerto-Logic'!
SystemOrganization addCategory: #'Aeropuerto-AsientoDeAvion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Persona-Test'!
SystemOrganization addCategory: #'Aeropuerto-SistemaDeReservas-Test'!
SystemOrganization addCategory: #'Aeropuerto-SistemaDeDescuento'!
SystemOrganization addCategory: #'Aeropuerto-Vuelo-Test'!
SystemOrganization addCategory: #'Aeropuerto-Avion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Pasajes-Test'!
SystemOrganization addCategory: #'Aeropuerto-Jet-Test'!
SystemOrganization addCategory: #'Aeropuerto-Comercial-Test'!

TestCase subclass: #AvionTest
	instanceVariableNames: 'jet comercial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Avion-Test'!

!AvionTest methodsFor: 'running' stamp: 'LeandroGomez 7/3/2012 01:43'!
setUp
	jet := Avion newNombre: 'Jet-1' tipo: TipoJet new.
	comercial := Avion newNombre: 'Comercial-1' tipo: TipoComercial new.
	! !

!AvionTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 01:43'!
testComercialCantidadDeAsientos
	self assert: (comercial  cantidadDeAsientos = 200).! !

!AvionTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 01:42'!
testComercialVelocidadPromedio
	self assert: (comercial velocidadPromedio  = 800).! !

!AvionTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 01:42'!
testJetCantidadDeAsientos
	self assert: (jet cantidadDeAsientos = 60).! !

!AvionTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 01:42'!
testJetVelocidadPromedio
	self assert: (jet velocidadPromedio  = 1200).! !

TestCase subclass: #ComercialTest
	instanceVariableNames: 'comercial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Comercial-Test'!

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:43'!
setUp 
	comercial := Avion newNombre: 'Avion-Comercial' tipo: TipoComercial new.
	! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testCantidadDeAsientos
	self assert: ( comercial cantidadDeAsientos = 200)! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre 
	self assert: (comercial nombre = 'Avion-Comercial')! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testVelocidadPromedio 
	self assert: ( comercial velocidadPromedio = 800 )! !

TestCase subclass: #JetTest
	instanceVariableNames: 'jet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Jet-Test'!

!JetTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:43'!
setUp 
	jet := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testCantidadDeAsientos
	self assert: (jet cantidadDeAsientos = 60)! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre
	self assert: (jet nombre = 'Avion-Jet')! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testVelocidadPromedio
	self assert: (jet velocidadPromedio = 1200)! !

TestCase subclass: #PasajeTest
	instanceVariableNames: 'business economica primera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Pasajes-Test'!

!PasajeTest methodsFor: 'running' stamp: 'LeandroGomez 7/3/2012 11:39'!
setUp 
	| jet persona vueloInternacional despegue|
	despegue := Date today addMonths: 4.
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	jet := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.
	vueloInternacional := Internacional newOrigen: 'Buenos Aires' destino: 'So Paulo' 
							avion: jet fechaDeSalida: despegue.
	primera := Pasaje newPersona: persona vuelo: vueloInternacional 
					nroAsiento: 37 tipoPasaje: Primera new.
	business := Pasaje newPersona: persona vuelo: vueloInternacional 
					nroAsiento: 27tipoPasaje: Business  new.
	economica := Pasaje newPersona: persona vuelo: vueloInternacional
					 nroAsiento: 17tipoPasaje: Economica new.! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:34'!
testBusinessCosto
	|costo|
	costo := business costoPara: SinDescuentos new.
	self assert: (costo = 750)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:35'!
testBusinessCostoALaFecha
	|costo|
	costo := business costoALaFecha: (Date today addMonths: 2) para: SinDescuentos  new.
	self assert: (costo = 1000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:36'!
testBusinessCostoPorClase
	|costo|
	costo := business costoPorClase.
	self assert: (costo  = 0.75)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:36'!
testBusinessDestino
	self assert: (business destino  = 'So Paulo')! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:36'!
testBusinessDistancia
	self assert: (business distancia  = 2000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/6/2012 14:55'!
testBusinessEstado
	self assert: (business vuelo esperaDespegue )! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:37'!
testBusinessFechaDespegue
	self assert: (business fechaDespegue = (Date today addMonths: 4))! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:30'!
testPrimeraCosto
	|costo|
	costo := primera costoPara: SinDescuentos new.
	self assert: (costo = 1000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:29'!
testPrimeraCostoALaFecha
	|costo|
	costo := primera costoALaFecha: (Date today addMonths: 2) para: SinDescuentos  new.
	self assert: (costo = 1333)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:18'!
testPrimeraCostoPorClase
	|costo|
	costo := primera costoPorClase.
	self assert: (costo = 1)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:31'!
testPrimeraDestino
	self assert: (primera destino  = 'So Paulo')! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:32'!
testPrimeraDistancia
	self assert: (primera distancia  = 2000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/6/2012 14:54'!
testPrimeraEstado
	self assert: (primera vuelo esperaDespegue)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 7/3/2012 11:33'!
testPrimeraFechaDespegue
	self assert: (primera fechaDespegue = (Date today addMonths: 4))! !

TestCase subclass: #PersonaTest
	instanceVariableNames: 'persona'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Persona-Test'!

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 12:21'!
setUp 
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/3/2012 01:32'!
testApellido
	self assert: (persona apellido = 'Gomez')! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/3/2012 01:31'!
testFechaNacimiento
	self assert: (persona fnacimiento = '5 may 1992' asDate)! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
testNacionalidad
	self assert: ( persona nacionalidad = 'Argentino' )! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:40'!
testNombre
	self assert: (persona nombre = 'Leandro')! !

TestCase subclass: #SistemaDeDescuentoTest
	instanceVariableNames: 'sinDescuento descuentoASaoPaulo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-SistemaDeDescuento'!

!SistemaDeDescuentoTest methodsFor: 'running' stamp: 'LeandroGomez 7/3/2012 23:12'!
setUp
	sinDescuento := SinDescuentos new.
	descuentoASaoPaulo := DescuentoASaoPaulo new.! !

!SistemaDeDescuentoTest methodsFor: 'tests' stamp: 'LeandroGomez 7/4/2012 00:05'!
testDescuentoASaoPaulo
	| pasaje |
	pasaje := SistemaDeReservas  test pasajes first.
	self assert: ((descuentoASaoPaulo descuentoParaPasaje: pasaje) = 1)! !

!SistemaDeDescuentoTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 23:24'!
testSinDescuento
	self assert: ((descuentoASaoPaulo descuentoParaPasaje: (SistemaDeReservas test pasajes first)) = 1)! !

TestCase subclass: #SistemaDeReservasTest
	instanceVariableNames: 'sistemaDeReservas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-SistemaDeReservas-Test'!

!SistemaDeReservasTest methodsFor: 'running' stamp: 'LeandroGomez 7/3/2012 23:23'!
setUp 
	sistemaDeReservas := SistemaDeReservas defaultTest. 


! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:18'!
testAgregarAvion
	| avion |
	avion := sistemaDeReservas agregarAvion: 'Jet-2' tipo: TipoJet new.
	self assert: (sistemaDeReservas existeAvionLlamado: 'Jet-2')! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 12:41'!
testAgregarPersona
	| persona |
	persona := sistemaDeReservas agregarPersonaNombre: 'Nathalia' apellido: 'Cruz' 
					fnacimiento: '5 june 1996' asDate nacionalidad: 'Brasilea'.
	self assert: ( sistemaDeReservas estaPersonaNombre: 'Nathalia' apellido: 'Cruz' 
						fnacimiento: '5 june 1996' asDate  nacionalidad: 'Brasilea' ).
	self assert: (sistemaDeReservas estaPersona: persona)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:17'!
testAgregarVueloInternacional
	sistemaDeReservas agregarVueloOrigen: 'Buenos Aires' destino: 'Sao Paulo' 
		avion: (sistemaDeReservas avionLlamado: 'Comercial-1') fechaSalida: ((Date today) addMonths: 5).
		
	self assert: ( sistemaDeReservas existeVueloOrigen: 'Buenos Aires' destino: 'Sao Paulo' 
			avion: (sistemaDeReservas avionLlamado: 'Comercial-1') fechaSalida: ((Date today) addMonths: 5))! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:24'!
testAgregarVueloTransbordo
	sistemaDeReservas agregarVueloOrigen: 'Buenos Aires' destino: 'Sao Paulo' 
			avion: (sistemaDeReservas avionLlamado: 'Comercial-1')
			fechaSalida: ((Date today) addMonths: 5) 
			siguienteVuelo: 
					(sistemaDeReservas agregarVueloOrigen: 'Sao Paulo' destino: 'Fortaleza' 
						avion: (sistemaDeReservas avionLlamado: 'Comercial-1') 
							fechaSalida: ((Date today) addMonths: 5)). 
	self assert: ( sistemaDeReservas existeVueloOrigen: 'Buenos Aires' destino: 'Sao Paulo' avion: (sistemaDeReservas avionLlamado: 'Comercial-1') fechaSalida:  ((Date today) addMonths: 5) siguienteVuelo: (sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 5)) )! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:33'!
testCancelar
	sistemaDeReservas cancelar: (sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida:  ((Date today) addMonths: 4) ).
	self assert: (sistemaDeReservas estaCancelado:(sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida:  ((Date today) addMonths: 4) ) )! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:24'!
testCantidadDeAsiento
	| avion |
	avion := sistemaDeReservas agregarAvion: 'Jet-2' tipo: TipoJet new.
	
	self assert: ((sistemaDeReservas cantidadDeAsientos: avion) = 60 )! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:13'!
testConfirmarAsiento
	| vuelo |
	vuelo := sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' 
						fechaSalida: ((Date today) addMonths: 4).
	sistemaDeReservas  confirmar: 37 vuelo: vuelo.
	self assert: (sistemaDeReservas estaConfirmado:  37 vuelo: vuelo)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 23:01'!
testCostoPasaje
	self assert: ((sistemaDeReservas costo: (sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today)addMonths: 4 ))tipo: Business new) = 750)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 23:01'!
testCostoPasajeALaFecha
	self assert: ((sistemaDeReservas costo: (sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today)addMonths: 4 )) aLaFecha: Date today tipo: Business new) = 750)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:34'!
testDestinoFinal
	self assert: ((sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida:((Date today) addMonths: 4)) destinoFinal = 'Fortaleza')! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:35'!
testDistanciaPromedio 
	self assert: ((sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida:((Date today) addMonths: 4)) distanciaPromedio = 4000)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:35'!
testDuracion
	self assert: ((sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida:((Date today) addMonths: 4)) duracion  =  (20/3))! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:42'!
testEsPasajero
	self assert: (sistemaDeReservas esPasajero: (sistemaDeReservas personaNombre: 'Leandro' apellido:  'Gomez' fnacimiento: '5 may 1992' asDate ) asiento: 37 vuelo: (sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4)))! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:41'!
testEsperaDespegue
	self assert: (sistemaDeReservas esperaDespegue: (sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4)))! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 12:48'!
testEstaPersona
	| persona |
	persona := sistemaDeReservas agregarPersonaNombre: 'Nathalia' apellido: 'Cruz' 
					fnacimiento: '5 june 1996' asDate nacionalidad: 'Brasilea'.
	self assert: ( sistemaDeReservas estaPersonaNombre: 'Nathalia' apellido: 'Cruz' 
						fnacimiento: '5 june 1996' asDate  nacionalidad: 'Brasilea' ).
	self assert: ((sistemaDeReservas personaNombre: 'Nathalia' apellido: 'Cruz' 
						fnacimiento: '5 june 1996' asDate)=persona)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:26'!
testExisteAvion
	self assert: (sistemaDeReservas existeAvionLlamado: 'Jet-1')! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:52'!
testExisteVuelo
	self assert: (sistemaDeReservas existeVueloOrigen: 'Sao Paulo' destino: 'Fortaleza' avion: (sistemaDeReservas avionLlamado: 'Jet-1') fechaSalida: ((Date today)addMonths: 4 )).! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 23:06'!
testExpenderPasaje
	sistemaDeReservas expender: Economica new persona: (sistemaDeReservas personaNombre: 'Leandro' 	apellido: 'Gomez' fnacimiento: '5 may 1992' asDate) vuelo: (sistemaDeReservas vueloOrigen: 'Sao Paulo' 	destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4)) asiento: 27.
	self assert: (sistemaDeReservas existePasaje: Economica new persona: (sistemaDeReservas 	personaNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate) vuelo: (sistemaDeReservas 	vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4)) asiento: 27)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:14'!
testLiberarAsiento
	| vuelo |
	vuelo := sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' 
						fechaSalida: ((Date today) addMonths: 4).
	sistemaDeReservas  liberar: 37 vuelo: vuelo.
	self assert: (sistemaDeReservas estaLibre: 37 vuelo: vuelo)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:17'!
testPasajeroDelAsiento
	| persona vuelo|
	persona := sistemaDeReservas personaNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate.
	vuelo := sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' 
							fechaSalida: ((Date today)addMonths: 4).
	self assert: ((sistemaDeReservas pasajeroDelAsiento: 37 vuelo: vuelo)=persona)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 22:51'!
testReprogramar
	sistemaDeReservas reprogramar: ((Date today) addMonths: 5) vuelo: (sistemaDeReservas vueloOrigen: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4)).
	self assert: (sistemaDeReservas estaReprogramado: 'Sao Paulo' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 5))! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 13:13'!
testVelocidadPromedio
	| avion |
	avion := sistemaDeReservas avionLlamado: 'Jet-1'.
	self assert: (avion velocidadPromedio = 1200)! !

!SistemaDeReservasTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 12:53'!
testViajaEnVuelo
	| persona vuelo|
	persona := sistemaDeReservas personaNombre: 'Leandro' apellido: 'Gomez' 
						fnacimiento: '5 may 1992' asDate .
	vuelo := sistemaDeReservas vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' 
						fechaSalida: ((Date today) addMonths: 4).
	self assert: ( sistemaDeReservas viaja: persona vuelo: vuelo )! !

TestCase subclass: #TestAsientoDeAvion
	instanceVariableNames: 'libre reservado confirmado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-AsientoDeAvion-Test'!

!TestAsientoDeAvion methodsFor: 'running' stamp: 'LeandroGomez 6/11/2012 20:05'!
setUp 
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
							fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
							
	reservado := AsientoDeAvion newNumero: 73.
	reservado asignar: persona.
	confirmado := AsientoDeAvion newNumero: 37.
	confirmado asignar: persona; confirmar.
	libre := AsientoDeAvion newNumero: 28.! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 7/3/2012 01:29'!
testAsientoConfirmadoEstaOcupado
	self assert: ( confirmado estaOcupado  ).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoEstado
	self assert: (confirmado estaConfirmado).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoLiberar
	confirmado liberar.
	self assert: ( confirmado estaLibre)! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:15'!
testAsientoConfirmadoNumero
	self assert: ( confirmado numero = 37 ).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoConfirmadoPersona
	self assert: ( confirmado persona nombre = 'Leandro' ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/11/2012 20:06'!
testAsientoLibreAsignarPersona
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
						fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	libre asignar: persona.
	self assert: ( libre esPasajero: persona).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoLibreEstado
	self assert: (libre estaLibre).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:06'!
testAsientoLibreNumero
	self assert: ( libre numero = 28 ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoLibrePersona
	self assert: ( libre persona  = nil ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 7/1/2012 19:35'!
testAsientoLibreReservar
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate  nacionalidad: 'Argentino'.
	libre asignar: persona.
	self assert: ( libre estaReservado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoConfirmar
	reservado confirmar.
	self assert: ( reservado estaConfirmado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoEstado
	self assert: (reservado estaReservado).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoLiberar
	reservado liberar.
	self assert: ( reservado estaLibre  )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:05'!
testAsientoReservadoNumero
	self assert: ( reservado numero= 73 ).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoReservadoPersona
	self assert: ( reservado persona nombre = 'Leandro' ).! !

TestCase subclass: #VueloTest
	instanceVariableNames: 'internacional transbordo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Vuelo-Test'!

!VueloTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:45'!
setUp 
	| avion avion2|
	avion := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.

	internacional := Internacional newOrigen: 'So Paulo' destino: 'Fortaleza' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 3).
						
	transbordo := Transbordo newOrigen: 'Buenos Aires' destino: 'So Paulo' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 4) siguienteVuelo: internacional.
	
						! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:28'!
testInternacionalAsignarAPersona
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate  nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	self assert: ( internacional esPasajero: persona asiento: 37 ).
	self assert: (internacional viaja: persona)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/6/2012 14:48'!
testInternacionalAsignarConfirmarAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate  nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	internacional confirmar:  37.
	self assert: ( internacional estaConfirmado: 37  ).
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:35'!
testInternacionalCantidadDeAsientos
	self assert: (internacional cantidadDeAsientos  = 60)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:35'!
testInternacionalDestinoFinal
	self assert: (internacional destinoFinal = 'Fortaleza')
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:26'!
testInternacionalDistanciaPromedio
	self assert: ( internacional distanciaPromedio = 2000)! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:38'!
testInternacionalDuracion
	self assert: (internacional duracion  = (5/3) )
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:47'!
testInternacionalEsPasajeroAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	self assert:  (internacional esPasajero: persona asiento:  37).
	self assert: (internacional viaja: persona).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:40'!
testInternacionalEsperaDespegue
	self assert: (internacional esperaDespegue)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:41'!
testInternacionalEstaCancelado
	self deny: (internacional estaCancelado ).
	internacional cancelar.
	self assert: (internacional estaCancelado ).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:42'!
testInternacionalEstaConfirmado
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	self deny:  (internacional estaConfirmado: 37).
	internacional confirmar: 37.
	self assert: (internacional estaConfirmado: 37).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:43'!
testInternacionalEstaLibre
	self assert: (internacional estaLibre: 37).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:46'!
testInternacionalEstaReservado
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	self assert:  (internacional estaReservado: 37)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:27'!
testInternacionalLiberar
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate  nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	internacional liberar: 37.
	self assert: ( internacional estaLibre: 37  ).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:48'!
testInternacionalPasajeroDelAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	internacional asignar: persona asiento: 37.
	self assert:  (internacional pasajeroDelAsiento:  37) == persona.
	self assert: (internacional viaja: persona).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:31'!
testInternacionalReprogramar
	internacional reprogramar: (Date today addMonths: 4).
	self assert: ( internacional estaReprogramado).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:33'!
testInternacionalReprogramarConAvion
	| avion |
	avion := Avion newNombre: 'Jet-2' tipo: TipoJet new. 
	internacional reprogramar: (Date today addMonths: 4) avion: avion.
	self assert: (internacional avion = avion).
	self assert: ( internacional estaReprogramado).
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:49'!
testInternacionalSiguienteVuelo
	self assert:  (internacional siguienteVuelo == nil)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:21'!
testInternacionalcancelar
	internacional cancelar.
	self assert: ( internacional estaCancelado)! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:51'!
testTransbordoDistanciaPromedio
	self assert:  (transbordo  distanciaPromedio  = 4000)
	
! !

!VueloTest methodsFor: 'tests' stamp: 'LeandroGomez 7/3/2012 10:53'!
testTransbordoDuracion
	self assert:  (transbordo  duracion = 5).! !

Object subclass: #AsientoDeAvion
	instanceVariableNames: 'estado persona numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!AsientoDeAvion commentStamp: 'LeandroGomez 7/1/2012 19:21' prior: 0!
Representa un asiento de avin, el cual debe inicializarse con un numero. Si el estado es 'Libre', la variable persona debe ser nil. En caso de que el estado sea 'Reservado' o 'Confirmado'; la variable persona debe ser una instancia de la clase Persona 

Instance Variables:
	estado	<String> 
	persona <Persona>
	numero	<Integer>!

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:40'!
new
	self error: 'Un asiento de avion necesita un numero, use "newNumero: " '! !

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 7/1/2012 19:22'!
newNumero: unNumero
	"Devuelve una instancia, con su variable numero seteada"
	|asiento|
	asiento := super new.
	asiento numero: unNumero.
	^asiento.! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:10'!
< unAsiento
	^(self numero < unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:09'!
<= unAsiento
	^(self numero <= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
= unAsiento
	^(self numero = unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
> unAsiento
	^(self numero > unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:23'!
>= unAsiento
	^(self numero >= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:18'!
asignar: unaPersona
	" Asigna al asiento una persona, si este no est ocupado o reservado. 
		En caso contrario, manda una excepcion "
	self estado asignar: unaPersona unAsiento: self! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:18'!
confirmar
	"Cambia el estado del asiento a confirmado; si ya estaba reservado. 
		En caso de que el estado haya estado libre, mandar una excepcion"
	self estado confirmar: self.
	! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 19:25'!
esPasajero: unaPersona
	"Responde true si unaPersona es la misma que ocupa el asiento, en caso contrario responde false"
	^self persona == unaPersona.! !

!AsientoDeAvion methodsFor: 'private' stamp: 'LeandroGomez 7/4/2012 14:53'!
escribirEnDisco: aStream
	"private - Agrega al stream los datos del asiento, usado por la clase vuelo para la escritura de sus asientos"
	(self estaLibre)
		ifTrue: [ aStream nextPutAll: '<', self numero asString ,'><', self estado ,'>'; 
					nextPut:  Character cr. ]
		ifFalse: [ aStream nextPutAll: '<', self numero asString ,'><', self estado ,'>';
					 nextPut: $<;
					 nextPutAll: self persona nombre;
					 nextPut: $>;
					 nextPut: $<;
					 nextPutAll: self persona apellido;
					 nextPut: $>;
					 nextPut: $<;
					 nextPutAll: self persona fnacimiento asString;
					 nextPut: $>;
 					 nextPut: $<;
					 nextPutAll: self persona nacionalidad;
					 nextPut: $>;
					 nextPut: Character cr. ]
			 ! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:23'!
estaConfirmado
	"Responde true si el asiento esta confirmado, false en caso contrario"
	^self estado estaConfirmado.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:23'!
estaLibre
	"Responde true si el estado del asiento es libre, false en cualquier otro caso"
	^self estado estaLibre! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:23'!
estaOcupado
	"Responde true si el estado del asiento es ocupado o reservado, false si el asiento esta libre"
	^self estado estaOcupado ! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:26'!
estaReservado
	"Responde true si el asiento esta reservado, false en cualquier otro caso"
	^self estado estaReservado.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado
	^ estado! !

!AsientoDeAvion methodsFor: 'private' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado: anObject
	estado := anObject! !

!AsientoDeAvion methodsFor: 'initialize' stamp: 'LeandroGomez 7/5/2012 18:17'!
initialize 
	self estado: Libre new.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:26'!
liberar
	"Cambia el estado a libre, y quita la persona, si la hubiese"
	self estado liberar: self.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero
	^ numero! !

!AsientoDeAvion methodsFor: 'private' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero: anObject
	numero := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona
	^ persona! !

!AsientoDeAvion methodsFor: 'private' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona: anObject
	persona := anObject! !

!AsientoDeAvion methodsFor: 'printing' stamp: 'LeandroGomez 7/1/2012 19:32'!
printOn: aStream
	"Imprime el numero del asiento y su estado "
	 aStream nextPutAll: 'Asiento nro ', self numero asString , ' - ' , self estado. ! !

Object subclass: #Avion
	instanceVariableNames: 'nombre tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Avion commentStamp: 'LeandroGomez 7/1/2012 19:48' prior: 0!
Representa a un avion, con sus nombre y su tipo. El nombre no debe ser un String vacio.

Instance Variables:
	nombre	<String>
	tipo	<TipoComercial | TipoJet>!

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:41'!
new
	self error: 'Un avion necesita un nombre , use "newNombre: " '! !

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/23/2012 09:42'!
newNombre: unNombre tipo: unTipo
	|avion|
	avion := super new.
	avion nombre: unNombre.
	avion tipo: unTipo.
	^avion! !

!Avion methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 19:51'!
cantidadDeAsientos 
	"Responde con la cantidad de asientos que tiene el avion, dependiendo de su tipo"
	^self tipo cantidadDeAsientos! !

!Avion methodsFor: 'escritura' stamp: 'LeandroGomez 7/1/2012 19:51'!
escribirEnDiscoEnPath: unDirectorio
	"Crea un archivo 'aviones.txt' en el directorio unDirectorio, y en  escribe sus datos. En caso de existir el archivo, escribe los datos al final"
	| aStream |
	aStream := FileStream fileNamed: unDirectorio , '\aviones.txt'.
	aStream setToEnd.
	[aStream nextPut: $<;
			 nextPutAll: self nombre;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self tipo printString;
			 nextPut: $>;
			 nextPut: Character cr] ensure: [aStream close].
			 
			 ! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre
	^ nombre! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre: anObject
	nombre := anObject! !

!Avion methodsFor: 'printing' stamp: 'LeandroGomez 7/1/2012 19:52'!
printOn: aStream
	"Imprime el nombre del avion con su tipo"
	aStream nextPutAll: 'Avion ';
	   		 nextPutAll: self nombre;
			 nextPutAll: ' de tipo ';
			 nextPutAll: self tipo printString.! !

!Avion methodsFor: 'accessing' stamp: 'LeandroGomez 6/23/2012 09:42'!
tipo
	^ tipo! !

!Avion methodsFor: 'private' stamp: 'LeandroGomez 6/23/2012 09:42'!
tipo: anObject
	tipo := anObject! !

!Avion methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 19:50'!
velocidadPromedio
	"Responde con la velocidad promedios que tiene el avion, dependiendo de su tipo"
	^self tipo velocidadPromedio.! !

Object subclass: #EstadoAsiento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

EstadoAsiento subclass: #Confirmado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Confirmado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:17'!
asignar: unaPersona unAsiento: unAsiento
	self error: 'Asiento confirmado'! !

!Confirmado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:19'!
confirmar: unAsiento
	! !

!Confirmado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:28'!
estaConfirmado 
	^true! !

!Confirmado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:28'!
estaOcupado
	^true! !

!Confirmado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:28'!
estaReservado
	^true! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:16'!
asignar: unaPersona unAsiento: unAsiento
	self subclassResponsibility ! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:18'!
confirmar
	self subclassResponsibility ! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:30'!
estaConfirmado
	^false! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:30'!
estaLibre
	^false! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:30'!
estaOcupado.
	^false! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:30'!
estaReservado
	^false! !

!EstadoAsiento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:25'!
liberar: unAsiento
	unAsiento persona: nil.
	unAsiento estado: Libre new.
	! !

EstadoAsiento subclass: #Libre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Libre methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:16'!
asignar: unaPersona unAsiento: unAsiento
	unAsiento persona: unaPersona.
	unAsiento estado: Reservado new.! !

!Libre methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:20'!
confirmar: unAsiento
	self error: 'Asiento libre'! !

!Libre methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:32'!
estaLibre
	^true! !

!Libre methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:25'!
liberar: unAsiento
	self error: 'Asiento ya libre'! !

EstadoAsiento subclass: #Reservado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Reservado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:17'!
asignar: unaPersona unAsiento: unAsiento
	self error: 'Asiento reservado'! !

!Reservado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:20'!
confirmar: unAsiento
	unAsiento estado: Confirmado new.! !

!Reservado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:32'!
estaOcupado
	^true! !

!Reservado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:32'!
estaReservado 
	^true! !

Object subclass: #EstadoVuelo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

EstadoVuelo subclass: #Cancelado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:49'!
asignar: unaPersona asiento: nro vuelo: unVuelo
	self error: 'Vuelo cancelado, imposible asignar persona'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:49'!
cancelar: unVuelo
	self error: 'Vuelo ya cancelado'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:53'!
confirmar: nro vuelo: unVuelo
	self error: 'Vuelo ya confirmado, no se puede confirmar'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:30'!
esperaDespegue: unVuelo
	^false! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:30'!
estaCancelado: unVuelo
	^true! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:40'!
estaConfirmado: nro vuelo: unVuelo
	self error: 'Vuelo cancelado, todos los asiento cancelados'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:31'!
estaLibre: nro vuelo: unVuelo
	self error: 'Vuelo cancelado, todos los asiento cancelados'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:33'!
estaReprogramado: unVuelo
	^false
	! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:34'!
estaReservado: nro vuelo: unVuelo
	self error: 'Vuelo ya cancelado, todos los asientos cancelados'
	! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:40'!
liberar: nro vuelo: unVuelo
	self error: 'Vuelo ya cancelado, todos los asientos cancelados'
	! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:50'!
printOn: aStream
	aStream nextPutAll: 'Cancelado'! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:41'!
reprogramar: unaFecha avion:unAvion  vuelo: unVuelo
	self error: 'Vuelo ya cancelado'
	! !

!Cancelado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:41'!
reprogramar: unaFecha vuelo: unVuelo
	self error: 'Vuelo ya cancelado'
	! !

EstadoVuelo subclass: #EsperaDespegue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:49'!
asignar: unaPersona asiento: nro vuelo: unVuelo
		(unVuelo asientos detect: [ :asiento | asiento numero = nro] ) asignar: unaPersona! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:48'!
cancelar: unVuelo
	unVuelo estado: Cancelado new
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:46'!
confirmar: nroAsiento vuelo: unVuelo
	(unVuelo asientos detect: [ :asiento | asiento numero = nroAsiento ]) confirmar.
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:18'!
esperaDespegue: unVuelo
	^true
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:19'!
estaCancelado: unVuelo
	^false
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:21'!
estaConfirmado: nroAsiento vuelo: unVuelo
	^(unVuelo asientos detect: [ :asiento | asiento numero = nroAsiento ]) estaConfirmado 
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:21'!
estaLibre: nroAsiento vuelo: unVuelo
	^(unVuelo asientos detect: [ :asiento | asiento numero = nroAsiento ]) estaLibre. 
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:22'!
estaReprogramado: unVuelo
	^false
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:45'!
estaReservado: nroAsiento vuelo: unVuelo
	^(unVuelo asientos detect: [ :asiento | asiento numero = nroAsiento ]) estaReservado 
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:43'!
liberar: nroAsiento vuelo: unVuelo
	^(unVuelo asientos detect: [ :asiento | asiento numero = nroAsiento ]) liberar  
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:50'!
printOn: aStream
	aStream nextPutAll: 'EsperaDespegue'! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:26'!
reprogramar: unaFecha avion: unAvion vuelo: unVuelo
	unVuelo fechaSalida: unaFecha.
	unVuelo avion: unAvion.
	unVuelo estado: Reprogramado new.
	! !

!EsperaDespegue methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:27'!
reprogramar: unaFecha vuelo: unVuelo
	self reprogramar: unaFecha avion: unVuelo avion vuelo: unVuelo
	! !

EsperaDespegue subclass: #Reprogramado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Reprogramado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:28'!
estaReprogramado: unVuelo
	^true! !

!Reprogramado methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 14:50'!
printOn: aStream
	aStream nextPutAll: 'Reprogramado'! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:47'!
asignar: unaPersona asiento: nro vuelo: unVuelo
	self subclassResponsibility 
	! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/5/2012 18:47'!
cancelar: unVuelo
	self subclassResponsibility 
	! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:38'!
confirmar: nroAsiento vuelo: unVuelo
	self subclassResponsibility 
	! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:40'!
esperaDespegue: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:40'!
estaCancelado: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:40'!
estaConfirmado: nroAsiento vuelo: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:40'!
estaLibre: nroAsiento vuelo: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:41'!
estaReprogramado: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:41'!
estaReservado: nro vuelo: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:38'!
liberar: nroAsiento vuelo: unVuelo
	self subclassResponsibility 
	! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:39'!
reprogramar: unaFecha avion:unAvion vuelo: unVuelo
	self subclassResponsibility ! !

!EstadoVuelo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/6/2012 13:39'!
reprogramar: unaFecha vuelo: unVuelo
	self subclassResponsibility ! !

Object subclass: #Pasaje
	instanceVariableNames: 'vuelo persona fReserva nroAsiento tipoPasaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Pasaje commentStamp: 'LeandroGomez 7/1/2012 20:11' prior: 0!
Representa un pasaje de para un vuelo, el cual indica a que vuelo pertenece, de quien es el vuelo, la fecha de la reserva, el numero del asiento en el vuelo y el tipo de pasaje.

Instance Variables:
	vuelo	<Vuelo>
	persona	<Persona>
	fReserva	<Date>
	nroAsiento	<Integer>
	tipoPasaje	<TipoPasaje>!

!Pasaje class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 10:23'!
newPersona: unaPersona vuelo: unVuelo nroAsiento: nroAsiento tipoPasaje: unTipo
	|pasaje|
	pasaje := super new.
	pasaje vuelo: unVuelo.
	pasaje persona: unaPersona.
	pasaje fReserva: Date today.
	pasaje nroAsiento: nroAsiento.
	pasaje tipoPasaje: unTipo.
	^pasaje.! !

!Pasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otroPasaje
	^self fReserva < otroPasaje fReserva! !

!Pasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 15:07'!
<= otroPasaje
	^self fReserva <= otroPasaje fReserva! !

!Pasaje methodsFor: 'private' stamp: 'LeandroGomez 7/3/2012 11:29'!
coeficientePorFecha: unaFecha
	"Private - Mediante la fecha, calcula un coeficiente para el calculo del costo. Mientras ms dias haya desde la fecha actual hasta la fecha unaFecha"
	|dias coef coefAux|
	dias := (self fechaDespegue - unaFecha) days.
	coef := 1.
	coefAux :=1.
	[ dias > (30*coefAux) ] whileTrue: [coef := coef + 0.5. dias := dias - (30*coefAux). coefAux := coefAux +1].
	^coef.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/3/2012 11:27'!
costoALaFecha: unaFecha para: unSistema
	"Devuelve el costo del pasaje , dependiendo del la fecha y del sistema de descuentos, mientras mas lejos de la fecha de despegue, menos saldr. "
	| descuento |
	
	descuento := unSistema descuentoParaPasaje: self.
	^(descuento * ((self tipoPasaje costoPorClase)*(self vuelo distanciaPromedio) / (self coeficientePorFecha: unaFecha)) rounded)! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/3/2012 11:06'!
costoPara: unSistema
	"Devuelve el costo del pasaje a la fecha actual"
	^(self costoALaFecha: Date today para: unSistema).! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 20:04'!
costoPorClase
	"Devuelve un coeficiente, dependiendo del tipo de pasaje"
	^self tipoPasaje costoPorClase.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 20:09'!
destino
	"Devuelve el destino final del vuelo"
	^self vuelo destinoFinal.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 20:05'!
distancia
	"Devuelve la distancia del vuelo"
	^self vuelo distanciaPromedio.
	! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 20:06'!
duracion 
	"Devuelve la duracion del vuelo"
	^self vuelo duracion.! !

!Pasaje methodsFor: 'writing' stamp: 'LeandroGomez 7/6/2012 14:52'!
escribirEnDiscoEnPath: unDirectorio
	"Crea un archivo 'pasajes.txt' en el directorio unDirectorio, y en  escribe sus datos. En caso de existir el archivo, escribe los datos al final"
	| aStream |
	aStream := FileStream fileNamed: unDirectorio , '\pasajes.txt'.
	[aStream setToEnd.
	aStream nextPut: $<;
			 nextPutAll: self persona nombre;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self persona apellido;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self persona fnacimiento asString ;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self persona nacionalidad;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self vuelo origen;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self vuelo destino;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self vuelo destinoFinal;
			 nextPut: $>;
			 nextPut: $<;			
			 nextPutAll: self vuelo fechaSalida asString;
			 nextPut: $>;
			 nextPut: $<;	
			 nextPutAll: self nroAsiento asString;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self tipoPasaje printString;
			 nextPut: $>;	
			 nextPut: $<;
			 nextPutAll: self estado printString ;
			 nextPut: $>;	 
			 nextPut: Character cr.] ensure: [ aStream close ]! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/3/2012 01:25'!
estado
	^self vuelo estado.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva
	^ fReserva! !

!Pasaje methodsFor: 'private' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva: anObject
	fReserva := anObject! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 20:09'!
fechaDespegue
	"Devuelve la fecha de despegue del vuelo"
	^self vuelo fechaSalida.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento
	^ nroAsiento! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento: anObject
	nroAsiento := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona
	^ persona! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona: anObject
	persona := anObject! !

!Pasaje methodsFor: 'printing' stamp: 'LeandroGomez 7/3/2012 23:09'!
printOn: aStream
	"Imprime el tipo de pasaje, la persona, el origen, el destino final del vuelo, el numero del asiento q ocupa en el vuelo, y su fecha de despegue"
	aStream nextPutAll:  'Pasaje ', self tipoPasaje printString , ' de ' , 
						 self persona printString ,
						 ' desde ',
						 self vuelo origen, 
						 ' hasta ', 
						 self vuelo destinoFinal, 
						 '. Asiento nro ',
						 self nroAsiento asString,
						 '. Fecha desegue ' , self fechaDespegue asString.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 10:33'!
tipoPasaje
	^ tipoPasaje! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 10:33'!
tipoPasaje: anObject
	tipoPasaje := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo
	^ vuelo! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo: anObject
	vuelo := anObject! !

Object subclass: #Persona
	instanceVariableNames: 'nombre apellido fnacimiento nacionalidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Persona commentStamp: 'LeandroGomez 7/1/2012 20:14' prior: 0!
Represnta a una persona, con su nombre, apellido, fecha de nacimiento y nacionalidad

Instance Variables:
	nombre	<String >
	apellido	<String >
	fnacimiento	<Date>
	nacionalidad	<String>!

!Persona class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
newNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	|persona|
	persona := super new.
	persona nombre: unNombre;
			apellido: unApellido;
			fnacimiento: unaFecha asDate;
			nacionalidad: unaNacionalidad.
	^persona.! !

!Persona methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otraPersona
	^self fnacimiento < otraPersona fnacimiento.! !

!Persona methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 14:42'!
<= otraPersona
	^self fnacimiento <= otraPersona fnacimiento.! !

!Persona methodsFor: 'comparing' stamp: 'LeandroGomez 7/1/2012 23:08'!
= otraPersona
	^(self fnacimiento = otraPersona fnacimiento) & (self nombre = otraPersona nombre ) 
				& (self apellido = otraPersona apellido) & (self nacionalidad = otraPersona nacionalidad)! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido
	^ apellido! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido: anObject
	apellido := anObject! !

!Persona methodsFor: 'writing' stamp: 'LeandroGomez 7/4/2012 10:34'!
escribirEnDiscoEnPath: unDirectorio
	"Crea un archivo 'persona.txt' en el directorio unDirectorio, y en  escribe sus datos. En caso de existir el archivo, escribe los datos al final"
	| aStream |
	aStream := FileStream fileNamed: unDirectorio , '\personas.txt'.
	aStream setToEnd.
	[aStream nextPut: $<;
			 nextPutAll: self nombre;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self apellido;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self fnacimiento asString;
			 nextPut: $>;
 			 nextPut: $<;
			 nextPutAll: self nacionalidad;
			 nextPut: $>;
			 nextPut: Character cr. ] ensure: [ aStream close ]! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento
	^ fnacimiento! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento: anObject
	fnacimiento := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad
	^ nacionalidad! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad: anObject
	nacionalidad := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'printing' stamp: 'LeandroGomez 7/1/2012 20:12'!
printOn: aStream 
	"Imprime su nombre, apellido y nacionalidad"
	aStream nextPutAll: self nombre, ' ', self apellido ,' ', self nacionalidad.! !

Object subclass: #SistemaDeDescuento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!SistemaDeDescuento commentStamp: 'LeandroGomez 7/1/2012 20:15' prior: 0!
Representa un sistema de descuentos de pasajes, sirve para saber el costo de un pasaje en una instacia de la clase 'SistemaDeReservas'. Esta clase existe para ser subclasificada.!

SistemaDeDescuento subclass: #DescuentoASaoPaulo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!DescuentoASaoPaulo commentStamp: 'LeandroGomez 7/1/2012 20:16' prior: 0!
sistema de descuentos, que le agrega descuento a los pasajes que son a 'Sao Paulo'!

!DescuentoASaoPaulo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/1/2012 20:17'!
descuentoParaPasaje: unPasaje
	"Devuelve el coeficiente por el que se dividir al costo sin descuento, si este tiene como destino 'Sao Paulo' "
	( unPasaje destino = 'Sao Paulo' )
		ifTrue: [^0.5]
		ifFalse: [^1]! !

SistemaDeDescuento subclass: #SinDescuentos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!SinDescuentos commentStamp: 'LeandroGomez 7/1/2012 20:18' prior: 0!
Representa a un SistemaDeDescuento que no hace descuentos. es el sistema default al inicializar un SistemaDeReservas!

!SinDescuentos methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/1/2012 20:18'!
descuentoParaPasaje: unPasaje
	"Devuelve un coeficiente que no afectar el resultado del costo" 
	^1! !

!SistemaDeDescuento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:49'!
descuentoParaPasaje: unPasaje
	self subclassResponsibility.! !

Object subclass: #SistemaDeReservas
	instanceVariableNames: 'folder pasajes vuelos personas aviones sistemaDeDescuento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance test'!

!SistemaDeReservas commentStamp: 'LeandroGomez 7/1/2012 22:14' prior: 0!
Representa un sistema de reservas de pasajes de vuelos. Deveria hacerse uso de su unica instancia(uniqueInstance) para acceder a una base de datos comun, es capas de tomar los datos de disco y volvarlos al mismo. La variable de clase 'test' esta creada para hacer test si afectar la base de datos.

Instance Variables:
	folder	<String >
	pasajes	<Collection of: (Pasaje) >
	vuelos	<(Collection of: (Internacional | Transbordo)) >
	personas	<Collection of: (Persona)>
	aviones	<(Collection of: (Avion) >
	sistemaDeDescuento	<SistemaDeDescuento>

Class Instance Variables:
	uniqueInstance	<SistemaDeReservas>
	test	<SistemaDeReservas>!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance test'!

!SistemaDeReservas class methodsFor: 'defaults' stamp: 'LeandroGomez 7/1/2012 22:15'!
default
	"Crea una carpeta en la carpeta default de Pharo, para guardar la base de datos alli"
	^ self defaultOnFolder:  (FileDirectory default) pathName , '\BaseDeDatos-Aeropuerto'! !

!SistemaDeReservas class methodsFor: 'defaults' stamp: 'LeandroGomez 7/1/2012 22:14'!
defaultOnFolder: unDirectorio
	| sistema |
	"unDirectorio es la carpeta donde se guardar la base de datos del programa"
	uniqueInstance := super new.
	uniqueInstance folder: unDirectorio.
	(FileDirectory on: unDirectorio) assureExistence.
	(FileStream forceNewFileNamed: unDirectorio , '\aviones.txt') close.
	(FileStream forceNewFileNamed: unDirectorio , '\vuelos-Transbordos.txt')close.
	(FileStream forceNewFileNamed: unDirectorio , '\vuelos-Internacional.txt')close.
	(FileStream forceNewFileNamed: unDirectorio , '\personas.txt')close.
	(FileStream forceNewFileNamed: unDirectorio,  '\pasajes.txt')close.
	^uniqueInstance.
	! !

!SistemaDeReservas class methodsFor: 'test instance creation' stamp: 'LeandroGomez 7/3/2012 23:20'!
defaultTest
	"Crea un sistema de reservas para tests"
	test := self defaultOnFolder: (FileDirectory default) pathName , '\Test-Aeropuerto'.
	"Personas"
	test agregarPersonaNombre: 'Leandro' apellido: 'Gomez' 
			fnacimiento: '5 may 1992' asDate  nacionalidad: 'Argentino'.
	test agregarPersonaNombre: 'Juan' apellido: 'Perez' 
			fnacimiento: '16 november 1990' asDate  nacionalidad: 'Chileno'.
	"Aviones"
	test agregarAvion: 'Jet-1' tipo: TipoJet new.
	test agregarAvion: 'Comercial-1' tipo: TipoComercial  new.
	"Vuelos"
	test agregarVueloOrigen: 'Buenos Aires' destino: 'Sao Paulo' 
			avion: (test avionLlamado: 'Comercial-1') fechaSalida: ((Date today) addMonths: 4) 
			siguienteVuelo: 
					(test agregarVueloOrigen: 'Sao Paulo' destino: 'Fortaleza' 
					avion: (test avionLlamado: 'Jet-1') fechaSalida: ((Date today) addMonths: 4)).
	"Pasajes"
	test expender: Business new persona: (test personaNombre: 'Leandro' apellido: 'Gomez' 
									fnacimiento: '5 may 1992' asDate) vuelo: 
		(test vueloOrigen: 'Buenos Aires' destinoFinal: 'Fortaleza' fechaSalida: ((Date today) addMonths: 4) ) 									asiento: 37.
	
	^test.! !

!SistemaDeReservas class methodsFor: 'instance creation' stamp: 'LeandroGomez 7/1/2012 22:16'!
new
	self error: 'Solo hay una unica instancia de esta clase'! !

!SistemaDeReservas class methodsFor: 'uniqueInstance' stamp: 'LeandroGomez 7/3/2012 23:20'!
test
	test ifNil: [ test := self defaultTest ].
	^test.! !

!SistemaDeReservas class methodsFor: 'uniqueInstance' stamp: 'LeandroGomez 7/3/2012 11:53'!
uniqueInstance
	uniqueInstance ifNil: [ uniqueInstance := self default ].
	^uniqueInstance.! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 7/3/2012 13:25'!
agregarAvion: unNombre tipo: unTipoAvion
	"Crea y agrega un avion, tabien la escribe en la base de datos"
	| avion |
	(self existeAvionLlamado: unNombre)
		ifTrue: [ self error: 'Ya existe el Avion' ]
		ifFalse: [ 
			avion := Avion newNombre: unNombre tipo: unTipoAvion.
			self aviones add:  avion. 
			avion escribirEnDiscoEnPath: self folder.
			^avion
				 ]! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 7/1/2012 23:24'!
agregarPasaje: unPasaje
	"Private - Agrega el pasaje sin escribirlo en disco"
	self pasajes add: unPasaje.! !

!SistemaDeReservas methodsFor: 'operacion sobre persona' stamp: 'LeandroGomez 7/3/2012 12:36'!
agregarPersonaNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	"Agrega una persona, y luego la escribe en disco. luego la devuelve"
	| persona |
	persona := Persona newNombre: unNombre apellido: unApellido 
						fnacimiento: unaFecha nacionalidad: unaNacionalidad.
	^self personas detect: [:personaA | self estaPersona:persona] 
						ifNone: [self personas add: persona. 
								persona escribirEnDiscoEnPath: self folder.
								^persona].
! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/3/2012 11:48'!
agregarVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha 
	"Agrega un vuelo Internacional, y luego lo escribe en disco"
	| vuelo |
	(self existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha )
	      ifTrue: [self error: 'Ya existe el vuelo'] 
		ifFalse: [ 
					vuelo :=(Internacional  newOrigen: unOrigen destino: unDestino 
										  avion: unAvion fechaDeSalida: unaFecha).
					self vuelos add: vuelo. 
				 	vuelo escribirEnDiscoEnPath: self folder.
				].
	^vuelo	
	! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/3/2012 11:49'!
agregarVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo:  unVuelo
	"Agrega un vuelo Transbordo, y luego lo escribe en disco"
	| vuelo |
	(self existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo: unVuelo)
	      ifTrue: [self error: 'Ya existe el vuelo'] 
		ifFalse: [ 
					vuelo :=(Transbordo  newOrigen: unOrigen destino: unDestino 
										  avion: unAvion fechaDeSalida: unaFecha siguienteVuelo: unVuelo).
					self vuelos add: vuelo. 
				 	vuelo escribirEnDiscoEnPath: self folder.
					^vuelo
				]
		
	! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 7/1/2012 23:25'!
asignar: unaPersona asiento: nroAsiento vuelo: unVuelo
	"Asigna una persona a un asiento, de un vuelo particular"
	unVuelo asignar: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 7/1/2012 22:23'!
avionLlamado: unNombre
	"Devuelve el avion llamado unNombre"
	^(self aviones detect: [:avion | avion nombre = unNombre] ifNone: [ self error: 'No existe el avion' ] )! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones
	^ aviones! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones: anObject
	aviones := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:17'!
cancelar: vuelo
	"Cancela un Vuelo"
	vuelo cancelar! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 7/1/2012 22:56'!
cantidadDeAsientos: unAvion
	"Devuelve la cantidad de asientos de avion"
	^unAvion cantidadDeAsientos.
	! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/3/2012 13:18'!
cargarAviones: aFullPath
	"Carga los aviones guardados en el path unFullPath"
	| avionesTXT char nombre tipo tipoAvion |
	avionesTXT := FileStream readOnlyFileNamed:  aFullPath.
	[avionesTXT atEnd] 
	whileFalse: [
			nombre:= ''.
			tipo := ''.
			"Cargar el nombre"
			nombre := self datosHastaTag: avionesTXT.
			"Cargar el tipo" 
			tipo := self datosHastaTag: avionesTXT.
			"Creo el avion" 
			(tipo = 'Jet')
				ifTrue: [ tipoAvion := TipoJet new ]
				ifFalse: [ tipoAvion := TipoComercial new  ].
			(self existeAvionLlamado: nombre)
			ifFalse: [self aviones add: (Avion newNombre: nombre tipo: tipoAvion).].
			"Ignoro los Caracteres hasta la siguiente linea"
			 avionesTXT next.
					].
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:27'!
cargarAvionesDefault
	"Carga los aviones del archivo default para la base de datos"
	self cargarAviones: self folder , '\aviones.txt'.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/2/2012 00:15'!
cargarPasajes: aFullPath
	"Carga los pasajes guardados en el path unFullPath"
	| pasajesTXT pasaje nombre apellido fnacimiento nacionalidad origen estado
			destino  destinoFinal fechaSalida  nroAsiento tipoPasaje persona vuelo tipo|
	pasajesTXT := FileStream readOnlyFileNamed:  aFullPath.
	[pasajesTXT atEnd] 
	whileFalse: [
			origen :=''.
			destino := ''.
			destinoFinal := ''.
			fechaSalida := ''.
			nroAsiento := ''.		
			tipoPasaje := ''.
			estado := ''.
			"Cargar el nombre"
			nombre := self datosHastaTag: pasajesTXT.
			"Cargar el apellido"
			apellido  := self datosHastaTag: pasajesTXT.
			"Cargar el fnacimiento "
			fnacimiento  := self datosHastaTag: pasajesTXT.
			"Cargar el nacionalidad "
			nacionalidad  := self datosHastaTag: pasajesTXT.
			"Cargar el origen"
			origen := self datosHastaTag: pasajesTXT.
			"Cargar el destino" 
			destino := self datosHastaTag: pasajesTXT.
			"Cargar el destinoFinal "
			destinoFinal  := self datosHastaTag: pasajesTXT.
			"Cargar el fechaSalida " 
			fechaSalida  := self datosHastaTag: pasajesTXT.
			"Cargar el nroAsiento "
			nroAsiento  := self datosHastaTag: pasajesTXT.
			"Cargar el tipoPasaje " 
			tipoPasaje  := self datosHastaTag: pasajesTXT.
			"Cargar el estado"
			estado  := self datosHastaTag: pasajesTXT.
			"Busco/creo los datos"
			"persona"
			persona := self agregarPersonaNombre: nombre apellido: apellido 
			fnacimiento: fnacimiento asDate nacionalidad: nacionalidad.
			"Vuelo"
			vuelo := self vueloOrigen: origen destinoFinal: vuelo fechaSalida: fechaSalida asDate.		
			"TipoPasaje"
			(tipoPasaje = 'Business')
				ifTrue: [ tipo := Business new. ].
			(tipoPasaje = 'Primera')
				ifTrue: [ tipo := Primera new. ].
			(tipoPasaje = 'Economica')
				ifTrue: [ tipo := Economica new. ].
				
			"Creo el pasaje" 
			(self existePasaje:  tipo persona: persona vuelo: vuelo asiento: nroAsiento asInteger )
				ifFalse: [ self agregarPasaje: ((Pasaje newPersona: persona 
							vuelo: vuelo nroAsiento: nroAsiento asInteger  tipoPasaje: tipo) estado: estado) ].
			"Ignoro los Caracteres hasta la siguiente linea"
			 pasajesTXT next.
					].
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/2/2012 00:09'!
cargarPasajesDefault
	"CArga las personas del archivo default de la base de datos"
	self cargarPersonas: self folder , '\pasajes.txt'.
	! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:27'!
cargarPersonas: aFullPath
	"Carga las personas  guardadas en el path unFullPath"
	| personasTXT char nombre apellido fnacimientoString nacionalidad |
	personasTXT := FileStream readOnlyFileNamed:  aFullPath.
	[personasTXT atEnd] 
	whileFalse: [
			nombre:= ''.
			apellido := ''.
			fnacimientoString := ''.
			nacionalidad := ''.
			"Cargar el nombre"
			nombre := self datosHastaTag: personasTXT.
			"Cargar el apellido"
			apellido := self datosHastaTag: personasTXT.
			"Cargar fecha nacimiento"
			fnacimientoString := self datosHastaTag: personasTXT.
			"Cargar nacinoalidad"
			nacionalidad := self datosHastaTag: personasTXT.
			"Creo la persona"
			(self estaPersonaNombre: nombre apellido: apellido 
					fnacimiento: fnacimientoString asDate nacionalidad: nacionalidad )
					ifFalse: [ self personas add: (Persona newNombre: nombre apellido: apellido 
										fnacimiento: fnacimientoString asDate nacionalidad: nacionalidad ) 
							].
			"Ignoro los Caracteres hasta la siguiente linea"
			personasTXT next
					]. personasTXT close
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:28'!
cargarPersonasDefault
	"CArga las personas del archivo default de la base de datos"
	self cargarPersonas: self folder , '\personas.txt'.
	! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:29'!
cargarVuelosInternacional: aFullPath
	"Carga los vuelos internacionales guardados en el path unFullPath"
	| vuelosInterncaionTXT char origen destino destinoFinal avion fechaDespegueString estado|
	vuelosInterncaionTXT := FileStream readOnlyFileNamed:  aFullPath.
	[vuelosInterncaionTXT atEnd] 
	whileFalse: [
			origen= ''.
			destino := ''.
			avion := ''.
			fechaDespegueString := ''.
			"Cargar el origen"
			origen := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destino"
			destino := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destinoFinal"
			destinoFinal := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar avion"
			avion := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar fecha"
			fechaDespegueString := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar estado"
			estado := self datosHastaTag: vuelosInterncaionTXT.
			"Creo el Vuelo" 
			
			(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
						fechaSalida: fechaDespegueString asDate )
			ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
						avion: avion fechaDeSalida: fechaDespegueString asDate). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					].
	 		
			"Ignoro los Caracteres hasta la siguiente linea"
			char := vuelosInterncaionTXT next
					]. vuelosInterncaionTXT close.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:28'!
cargarVuelosInternacionalDefault
	"Carga los vuelos internacionales del archivo default de la base de datos"
	self cargarVuelosInternacional: self folder , '\vuelos-Internacional.txt'.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:29'!
cargarVuelosTransbordo: aFullPath
	"Carga los Vuelos Transbordos  guardados en el path unFullPath"
	| vuelosTransbordosTXT char origen destino destinoFinal avion fechaDespegueString estado siguienteVuelo|
	vuelosTransbordosTXT := FileStream readOnlyFileNamed:  aFullPath.
	[vuelosTransbordosTXT atEnd] 
	whileFalse: [
			origen:= ''.
			destino := ''.
			destinoFinal  := ''.
			avion := ''.
			estado:=''.
			fechaDespegueString := ''.
			"Cargar el origen"
			origen := self datosHastaTag: vuelosTransbordosTXT.
			"Cargar el destino"
			destino := self datosHastaTag: vuelosTransbordosTXT.
			"Cargar el destinoFinal"
			destinoFinal := self datosHastaTag: vuelosTransbordosTXT.
			"Cargar avion"
			avion := self datosHastaTag: vuelosTransbordosTXT.
			"Cargar fecha"
			fechaDespegueString := self datosHastaTag: vuelosTransbordosTXT.
			"Cargar estado"
			estado := self datosHastaTag: vuelosTransbordosTXT.
			"Cargo siguienteVuelo "
			( vuelosTransbordosTXT peek = $<)
				ifTrue: [siguienteVuelo := self obtenerSiguienteVuelo: vuelosTransbordosTXT.
						(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
									fechaSalida: fechaDespegueString asDate siguienteVuelo: siguienteVuelo)
						ifFalse: [| vuelo | vuelo :=(Transbordo  newOrigen: origen destino: destino 
									avion: (self avionLlamado: avion) 
										fechaDeSalida: fechaDespegueString asDate 
											siguienteVuelo: siguienteVuelo  ). 
						vuelo estado: estado.
						self vuelos add: vuelo.
								].
						
					]
				ifFalse: [(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
						fechaSalida: fechaDespegueString asDate )
						ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
						avion: (self avionLlamado: avion) fechaDeSalida: fechaDespegueString asDate). 
						vuelo estado: estado.
						self vuelos add: vuelo.
								].
						].
			"Ignoro los Caracteres hasta la siguiente linea"
			char := vuelosTransbordosTXT next
					]. vuelosTransbordosTXT close.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:29'!
cargarVuelosTransbordoDefault
	"Carga los vuelos desde el archivo default de la base de datos"
	self cargarVuelosTransbordo: self folder ,  '\vuelos-Transbordos.txt'.
		! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:46'!
confirmar: nroAsiento vuelo: unVuelo
	"Confirma un asiento de un vuelo en particular"
	unVuelo confirmar: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 7/1/2012 22:58'!
costo: unVuelo aLaFecha: unaFecha tipo: unTipo
	"Costo del pasaje a la fecha 'unaFecha' "
	"La persona es una persona default, con datos aleatorios"
	 | persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' nacionalidad: 'Argentino'.
	^(Pasaje newPersona: persona vuelo: unVuelo nroAsiento: 1 tipoPasaje: unTipo) costoALaFecha: unaFecha para: self sistemaDeDescuento ! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 6/23/2012 08:50'!
costo: unVuelo tipo: unTipo
	"Costo del pasaje a la fecha actual"
	^self costo: unVuelo aLaFecha: Date today tipo: unTipo.! !

!SistemaDeReservas methodsFor: 'operacion sobre tipoPasaje' stamp: 'LeandroGomez 7/1/2012 23:15'!
costoPorClase: unTipo
	"Devuelve el coeficiente de costo por clase"
	^unTipo costoPorClase! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 7/1/2012 23:30'!
datosHastaTag: aStream
	"Private. Lee todos los caracteres entre  < >. "
	| datos |
	datos := ''.
	aStream next.
	[ aStream peek ~= $> ]
		whileTrue: [  datos := datos , aStream next asString].
	aStream next.
	^datos.! !

!SistemaDeReservas methodsFor: 'operacion sobre sistemaDeDescuento' stamp: 'LeandroGomez 7/1/2012 23:15'!
descuentoParaDia: unaFecha tipoPasaje: unTipo
	"Devuelve el coeficiente de decuento para el dia"
	^self sistemaDeDescuento descuentoParaDia: unaFecha tipoPasaje: unTipo! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:17'!
destinoFinal: unVuelo
	"Devuelve el destino final de un vuelo"
	^unVuelo destinoFinal! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:17'!
distanciaPromedio: unVuelo
	"Devuelve la distancia promedio de un vuelo"
	^unVuelo distanciaPromedio.! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:17'!
duracion: unVuelo
	"Devuelve la duracion de un Vuelo"
	^unVuelo duracion! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:18'!
esPasajero: unaPersona asiento: nroAsiento vuelo: unVuelo
	"Devuelve true si la persona unaPersona, viaja en un vuelo unVuelo , en cierto asiento nroASiento"
	^unVuelo esPasajero: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/4/2012 10:54'!
escribirAsientosDeLosVuelosEnDisco
	self vuelos do: [ :vuelo | vuelo escribirAsientosEnPath: self folder].! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:18'!
esperaDespegue: unVuelo
	"Devuelve true si el vuelo unVuelo espera despegue"
	^unVuelo esperaDespegue ! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:19'!
estaCancelado: unVuelo
	"Devuelve true si el vuelo unVuelo esta cancelado"
	^unVuelo estaCancelado! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:47'!
estaConfirmado: nroAsiento vuelo:unVuelo
	"Responde true si el asiento del vuelo esta confirmado"
	^unVuelo estaConfirmado: nroAsiento ! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:47'!
estaLibre: nroAsiento vuelo: unVuelo
	"Responde true si el asiento del vuelo esta libre"
	^unVuelo estaLibre: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre persona' stamp: 'LeandroGomez 7/1/2012 23:06'!
estaPersona: unaPersona
	"Responde si ya hay una persona igual a esa"	
	^self personas anySatisfy: [ :each  | each = unaPersona ]! !

!SistemaDeReservas methodsFor: 'operacion sobre persona' stamp: 'LeandroGomez 7/1/2012 23:09'!
estaPersonaNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	"Responde true si exite una persona con ese nombre, apellido, fecha de acimiento y nacionalidad"
	^self personas anySatisfy: [ :each | (each nombre = unNombre) & (each apellido = unApellido) & 
											(each fnacimiento = unaFecha) &
											 ( each nacionalidad  = unaNacionalidad ) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/4/2012 15:17'!
estaReprogramado: unVuelo
	^unVuelo estaReprogramado.! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/3/2012 22:50'!
estaReprogramado: unOrigen destinoFinal: unDestino fechaSalida: unaFecha
	^(self vuelos anySatisfy: [ :vuelo | (vuelo origen = unOrigen) & (vuelo destinoFinal = unDestino) & (vuelo fechaSalida = unaFecha) & (vuelo estaReprogramado )])! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:47'!
estaReservado: nroAsiento vuelo: unVuelo
	"Responde true si el asiento del vuelo esta reservado"
	^unVuelo estaReservado: nroAsiento.! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 7/3/2012 13:18'!
existeAvionLlamado: unNombre
	"Responde true si existe un avion con ese nombre"
	^self aviones anySatisfy: [ :each | each nombre = unNombre]! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 7/3/2012 23:10'!
existePasaje: unTipo persona: unaPersona vuelo: unVuelo asiento: nroAsiento
	"Devuelve true si existe un pasaje de ese tipo, para esa persona, en ese vuelo y ese asiento"
	^self pasajes  anySatisfy: [ :pasaje | (pasaje tipoPasaje = unTipo ) &  (pasaje persona = unaPersona) & 
						(pasaje vuelo = unVuelo)  & (pasaje nroAsiento = nroAsiento ) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:21'!
existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha 
	"Responde true si existe un vuelo Internacional con ese origen, destino, avion y fecha de salida"
	^self vuelos anySatisfy: [ :each |  (each origen = unOrigen) & (each destino = unDestino) &
										(each fechaSalida = unaFecha)]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/3/2012 22:30'!
existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo:  unVuelo
	"Responde true si existe un vuelo Transbordo  con ese origen, destino, avion,
			 fecha de salida y ese vuelo siguiente"
	^self vuelos anySatisfy: [ :each |  (each origen = unOrigen) & (each destino = unDestino) &
										(each fechaSalida = unaFecha) & (each siguienteVuelo  = unVuelo) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 7/3/2012 23:08'!
expender: unTipo persona: unaPersona vuelo: unVuelo asiento: nroAsiento
	"Expende un pasaje. si el asiento esta ocupado, manda una excepcion"
	|pasaje|
	( self estaLibre: nroAsiento vuelo:  unVuelo)
			ifTrue: [ self asignar: unaPersona asiento: nroAsiento vuelo: unVuelo. 
					(unVuelo siguienteVuelo == nil)
						ifFalse: [self asignar: unaPersona asiento: nroAsiento 
										vuelo: unVuelo siguienteVuelo ].
					pasaje := (Pasaje  newPersona: unaPersona 
										vuelo:  unVuelo nroAsiento: nroAsiento 										tipoPasaje: unTipo) .
					self agregarPasaje: pasaje.
					pasaje escribirEnDiscoEnPath: self folder.
					]
			ifFalse: [ self error: 'asiento Ocupado' ]! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder
	^ folder! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder: anObject
	folder := anObject! !

!SistemaDeReservas methodsFor: 'initialization' stamp: 'LeandroGomez 6/17/2012 13:20'!
initialize 
	self pasajes: SortedCollection new;
		vuelos: SortedCollection new;
		personas: SortedCollection new;
		sistemaDeDescuento: SinDescuentos new;
		aviones: OrderedCollection new.! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:31'!
levantarBaseDeDatos
	"Levanta todos los archivos de la base de datos, desde sus archivos default"
	self cargarAvionesDefault. 
	self cargarVuelosTrasnbordoDefault.
	self cargarVuelosInternacionalDefault.
	self cargarPersonasDefault.
	self cargarPasajesDefault.
				! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:47'!
liberar: nroAsiento vuelo: unVuelo
	"Libera el asiento de un vuelo en particular"
	unVuelo liberar: nroAsiento! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 7/1/2012 23:32'!
obtenerSiguienteVuelo: aStream
	"Private. Obtiene el siguiente vuelos oara un vuelo Transbordo."
	| char origen destino destinoFinal avion fechaDespegueString estado siguienteVuelo vueloRet|
	[aStream atEnd] 
	whileFalse: [
		origen:= ''.
		destino := ''.
		destinoFinal := ''.
		avion := ''.
		fechaDespegueString := ''.
		"Cargar el origen"
		origen := self datosHastaTag: aStream.
		"Cargar el destino"
		destino := self datosHastaTag: aStream.
		"Cargar el destinoFinal"
		destinoFinal := self datosHastaTag: aStream.
		"Cargar avion"
		avion := self datosHastaTag: aStream.
		"Cargar fecha"
		fechaDespegueString := self datosHastaTag: aStream.
		"Cargar estado"
		estado := self datosHastaTag: aStream.
		"Cargo siguienteVuelo "
		( aStream peek = $<)
			ifTrue: [siguienteVuelo := self obtenerSiguienteVuelo: aStream.
					(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
								fechaSalida: fechaDespegueString asDate )
					ifFalse: [| vuelo | vuelo :=(Transbordo  newOrigen: origen destino: destino 
								avion: avion fechaDeSalida: fechaDespegueString asDate 
									siguienteVuelo: siguienteVuelo  ). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					vueloRet:= vuelo.
							].
				]
			ifFalse: [ (self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
					fechaSalida: fechaDespegueString asDate )
					ifTrue: [ self vueloOrigen: origen destinoFinal: destino fechaSalida: fechaDespegueString asDate ] 
					ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
					avion: (self avionLlamado: avion) fechaDeSalida: fechaDespegueString asDate). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					vueloRet:= vuelo.
							].
				].
			"Ignoro los Caracteres hasta la siguiente linea"
			char := aStream next
		].
	^vueloRet.! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 7/1/2012 22:47'!
pasajeroDelAsiento: nroAsiento vuelo: unVuelo
	"Devuelve el pasajero de un asiento de un vuelo en particular"
	^unVuelo pasajeroDelAsiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes
	^ pasajes! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes: anObject
	pasajes := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre persona' stamp: 'LeandroGomez 7/1/2012 23:14'!
personaNombre: unNombre apellido: unApellido fnacimiento: unaFecha
	"Devuelve la persona con ese nombre, apellido y fecha de nacimiento"
	^self personas detect: [:persona | (persona nombre = unNombre) & (persona apellido = unApellido)
										& (persona fnacimiento = unaFecha)] ifNone: [self error: 'No existe persona']! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas
	^ personas! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas: anObject
	personas := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:22'!
reprogramar: unaFecha avion: unAvion vuelo: unVuelo
	"Reprograma unVuelo para una fecha , con otro avion "
	unVuelo reprogramar: unaFecha avion: unAvion! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:23'!
reprogramar: unaFecha vuelo: unVuelo
	"Reprograma solo la fecha del vuelo"
	unVuelo reprogramar: unaFecha! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:32'!
sincronizarAviones
	"Sincroniza el archivo 'aviones.txt' con los aviones que contiene el sistema"
	(FileStream forceNewFileNamed: self folder , '\aviones.txt') close.
	self aviones do: [ :avion | avion escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/2/2012 00:11'!
sincronizarPersonas
	"Sincroniza el archivo 'personas.txt' con los respectivos vuelos que contiene el sistema"
	(FileStream forceNewFileNamed: self folder , '\personas.txt') close.
	self personas do: [ :persona | persona escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 23:33'!
sincronizarVuelos
	"Sincroniza el archivo 'vuelos-Internacional.txt' y 'vuelos-Transbordos.txt'  
			con los respectivos vuelos que contiene el sistema"
	| vuelosInter |
	(FileStream forceNewFileNamed: self folder , '\vuelos-Internacional.txt') close.
	(FileStream forceNewFileNamed: self folder , '\vuelos-Transbordos.txt') close.
	self vuelos do: [ :vuelo | vuelo escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 11:46'!
sistemaDeDescuento
	^ sistemaDeDescuento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 11:46'!
sistemaDeDescuento: anObject
	sistemaDeDescuento := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 7/1/2012 22:57'!
velocidadPromedio: unAvion
	"Devuelve la velocidad promedio de un avion"
	^unAvion velocidadPromedio! !

!SistemaDeReservas methodsFor: 'operacion sobre persona' stamp: 'LeandroGomez 7/1/2012 23:14'!
viaja: unaPersona vuelo: unVuelo
	"Responde true si la persona viaja en un vuelo en particular"
	^unVuelo viaja: unaPersona
	! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 7/1/2012 23:24'!
vueloOrigen: unOrigen destinoFinal: unDestino fechaSalida: unaFecha
	"Devuelve el vuelo que tiene ese origen, detino y fecha de salida"
	^self vuelos detect: [:vuelo | (vuelo origen = unOrigen) & (vuelo destinoFinal = unDestino) &
									(vuelo fechaSalida = unaFecha) ] ifNone: [self error: 'No existe Vuelo'].! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos
	^ vuelos! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos: anObject
	vuelos := anObject! !

Object subclass: #TipoAvion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoAvion commentStamp: 'LeandroGomez 7/1/2012 20:19' prior: 0!
Representa a un Tipo de avion, esta clase existe para ser subclasificada!

!TipoAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:23'!
cantidadDeAsientos 
	"Cantidad de asientos del avion"
	self subclassResponsibility.! !

!TipoAvion methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:23'!
velocidadPromedio 
	"Velocidad promedio del avion"
	self subclassResponsibility  ! !

TipoAvion subclass: #TipoComercial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoComercial commentStamp: 'LeandroGomez 7/1/2012 20:20' prior: 0!
Represnta un tipo de avion comercial, con cantidad de asientos igual a 200, y su velocidad maxima igual a 800.!

!TipoComercial methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:22'!
cantidadDeAsientos
	"Cantidad de asientos del avion"
	^200.! !

!TipoComercial methodsFor: 'printing' stamp: 'LeandroGomez 6/23/2012 10:36'!
printOn: aStream
	aStream nextPutAll: 'Comercial'.! !

!TipoComercial methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:22'!
velocidadPromedio
	"Velocidad promedio del avion"
	^800.! !

TipoAvion subclass: #TipoJet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoJet commentStamp: 'LeandroGomez 7/1/2012 20:20' prior: 0!
Represnta un tipo de avion Jet, con cantidad de asientos igual a 60, y su velocidad maxima igual a 1200.!

!TipoJet methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:22'!
cantidadDeAsientos
	"Cantidad de asientos del avion"
	^60.! !

!TipoJet methodsFor: 'printing' stamp: 'LeandroGomez 6/23/2012 10:36'!
printOn: aStream
	aStream nextPutAll: 'Jet'.! !

!TipoJet methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:22'!
velocidadPromedio
	"Velocidad promedio del avion"
	^1200.! !

Object subclass: #TipoPasaje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoPasaje commentStamp: 'LeandroGomez 7/1/2012 20:25' prior: 0!
Representa a un tipo de pasaje, la cual ser usada en las instancias de Pasaje. Esta clase existe para ser subclasificada!

TipoPasaje subclass: #Business
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Business methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.75! !

!Business methodsFor: 'printing' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Bussiness'.! !

TipoPasaje subclass: #Economica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Economica methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.5! !

!Economica methodsFor: 'printing' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Economico'.! !

TipoPasaje subclass: #Primera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Primera methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^1.! !

!Primera methodsFor: 'printing' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Primera'.! !

!TipoPasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/16/2012 10:42'!
= otroTipoPasaje
	^self costoPorClase = otroTipoPasaje costoPorClase.! !

!TipoPasaje methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 20:26'!
costoPorClase
	"Coeficiente de tipo pasaje, mientras mas alto, mas costar el pasaje "
	self subclassResponsibility.! !

Object subclass: #Vuelo
	instanceVariableNames: 'origen destino avion fechaSalida estado asientos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Vuelo commentStamp: 'LeandroGomez 7/1/2012 22:07' prior: 0!
Representa un Vuelo. En el se guardan los asientos ocupados. Esta clase existe para ser subclasificada

Instance Variables:
	origen	<String >
	destino	<String >
	avion	<Avion>
	fechaSalida	<Date>
	estado	<String >
	asientos	<(Collection of: AsientoDeAvion) >!

Vuelo subclass: #Internacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Internacional methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 22:01'!
distanciaPromedio
	"Devuelve la distancia promedio del vuelo"
	^2000.! !

!Internacional methodsFor: 'wirting' stamp: 'LeandroGomez 7/4/2012 10:34'!
escribirEnDiscoEnPath: unDirectorio
	"Crea un archivo 'vuelos-Internacional.txt' en el directorio unDirectorio, y en  escribe sus datos. En caso de existir el archivo, escribe los datos al final"
	| aStream asientosOcupados|
	aStream := FileStream fileNamed: unDirectorio , '\vuelos-Internacional.txt'.
	aStream setToEnd.
	[aStream nextPutAll: self tags;
			 nextPut: Character cr. ] ensure: [ aStream close ]! !

!Internacional methodsFor: 'operations' stamp: 'LeandroGomez 7/3/2012 01:20'!
siguienteVuelo
	^nil.! !

!Internacional methodsFor: 'private' stamp: 'LeandroGomez 7/6/2012 14:49'!
tags
	"Private, usado para imprimir los datos en disco"
	^'<', self origen,'><', self destino, '><', self destinoFinal , '><' , self avion nombre , '><', self fechaSalida asString , '><' , self estado printString , '>'.! !

Vuelo subclass: #Transbordo
	instanceVariableNames: 'siguienteVuelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:55'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha 
	self error: 'Para un vuelo transbordo se necesita otro vuelo internacional/transbordo'! !

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:46'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha siguienteVuelo: otroVuelo

	|transbordo|
	transbordo := super newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha.
	transbordo siguienteVuelo: otroVuelo.
	^transbordo.! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 22:05'!
destinoFinal
	"Devuelve el destino final del vuelo"
	^self siguienteVuelo destinoFinal.! !

!Transbordo methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 22:05'!
distanciaPromedio
	"Devuelve la distancia promedio del vuelo"
	^2000 + (self siguienteVuelo distanciaPromedio).! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 22:05'!
duracion
	"Devuelve la duracion del vuelo"
	^ super duracion + self siguienteVuelo duracion.! !

!Transbordo methodsFor: 'wirting' stamp: 'LeandroGomez 7/4/2012 10:35'!
escribirEnDiscoEnPath: unDirectorio
	"Crea un archivo 'vuelos-Transbordo.txt' en el directorio unDirectorio, y en  escribe sus datos. En caso de existir el archivo, escribe los datos al final"
	| aStream asientosOcupados|
	aStream := FileStream fileNamed: unDirectorio , '\vuelos-Transbordos.txt'.
	aStream setToEnd.
	[aStream nextPutAll: self tags;
			 nextPut: Character cr. ] ensure: [ aStream close ]
			
		
	





! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo
	^ siguienteVuelo! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo: anObject
	siguienteVuelo := anObject! !

!Transbordo methodsFor: 'private' stamp: 'LeandroGomez 7/6/2012 14:51'!
tags
	"Private, usado para imprimir los datos en disco"
	^'<', self origen,'><', self destino, '><', self destinoFinal , '><' , self avion nombre ,'><' ,self fechaSalida asString  ,  '><' , self estado printString , '>', self siguienteVuelo tags.! !

!Vuelo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 19:51'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha
	|vuelo|
	vuelo := super new.
	vuelo origen: unOrigen;
		   destino: unDestino;
		   avion: unAvion;
		   fechaSalida: unaFecha;
		   asientos: OrderedCollection new.
		   1 to: unAvion cantidadDeAsientos do: [ :nro | vuelo asientos add: 
															(AsientoDeAvion newNumero: nro)].
	 ^vuelo.
	! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:12'!
< unVuelo
	^ self fechaSalida < unVuelo fechaSalida.! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 15:00'!
<= unVuelo
	^ self fechaSalida <= unVuelo fechaSalida.! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/30/2012 08:26'!
= unVuelo
	^(self origen = unVuelo origen) & (self destinoFinal = unVuelo destinoFinal ) & 
			( self fechaSalida = unVuelo fechaSalida ) ! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/5/2012 18:43'!
asientoNro: nro
	self detect: [ :asiento | asiento numero = nro ]! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos
	^ asientos! !

!Vuelo methodsFor: 'private' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos: anObject
	asientos := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/6/2012 13:47'!
asignar: unaPersona asiento: nro
	"Asigna a una persona unaPersona en el asiento numero nro. 
		Si el asiento ya esta asignado, manda una excepcion"
		(nro <= self asientos size) & (nro >= 0)
		ifTrue: [self estado asignar: unaPersona asiento: nro vuelo: self]
		ifFalse: [ self error: 'El asiento no existe']

	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion
	^ avion! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion: anObject
	avion := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/5/2012 18:38'!
cancelar
	"Cancela el vuelo"
	self estado cancelar: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:53'!
cantidadDeAsientos 
	"Devuelve la cantidad de asientos del avion"
	^self avion cantidadDeAsientos.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/6/2012 13:48'!
confirmar: nro
	"Confirma el asiento numero nro del vuelo"
		(nro <= self asientos size) & (nro >= 0)
		ifTrue: [self estado confirmar: nro vuelo: self]
		ifFalse: [ self error: 'El asiento no existe']
	
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino
	^ destino! !

!Vuelo methodsFor: 'private' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino: anObject
	destino := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:53'!
destinoFinal
	"Devuelve el destino final del vuelo"
	^ self destino.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:48'!
distanciaPromedio
	"Devuelve la distancia promedio del vuelo."
	self subclassResponsibility.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:54'!
duracion
	"Devuelve la duracion del vuelo"
	^ self distanciaPromedio / self avion velocidadPromedio.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:54'!
esPasajero: unaPersona asiento: nroAsiento 
	"Devuelve true si la persona unaPersona es el pasajero del asiento numero nro"
	|asiento|
	asiento := self asientos detect: [ :asient | asient numero = nroAsiento ].
	^asiento  esPasajero: unaPersona.! !

!Vuelo methodsFor: 'wirting' stamp: 'LeandroGomez 7/4/2012 10:52'!
escribirAsientosEnPath: unDirectorio
	"Crea un archivo con el origen, destino y fecha de despegue de un vuelos como nombre, en el directorio unDirectorio, y en el escribe los asientos. En caso de existir el archivo,lo sobre escribe"
	| aStream asientosOcupados|
	aStream := FileStream forceNewFileNamed: unDirectorio , '\asientosDelVuelo-', 
					self origen,'-', self destinoFinal,'-', self fechaSalida asString , '.txt'.
	[self asientos do: [ :asiento | asiento escribirEnDisco: aStream ] ] ensure: [ aStream close ]! !

!Vuelo methodsFor: 'wirting' stamp: 'LeandroGomez 7/1/2012 21:59'!
escribirEnDiscoEnPath: unDirectorio
	"Escribe los datos del vuelo en disco, en el directorio unDirectorio"
	self subclassResponsibility.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 13:42'!
esperaDespegue 
	"Devuelve true si el vuelo espera despegue"
	^self estado esperaDespegue: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 13:42'!
estaCancelado
	"Devuelve true si el vuelo esta cancelado"
	^self estado estaCancelado: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 13:42'!
estaConfirmado: nroAsiento
	"devuelve true si el asiento numero nro esta confirmado"
	^self estado estaConfirmado: nroAsiento  vuelo: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 14:44'!
estaLibre: nroAsiento
	"Devuelve true si el asiento numero nro esta libre"
	^self estado estaLibre: nroAsiento  vuelo: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 13:43'!
estaReprogramado
	"Devuelve true si el vuelo esta cancelado"
	^self estado estaReprogramado: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 13:43'!
estaReservado: nroAsiento
	"Devuelve true si el asiento numer nro esta Reservado"
	^self estado estaReservado:  nroAsiento  vuelo: self! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado
	^ estado! !

!Vuelo methodsFor: 'private' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado: anObject
	estado := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:49'!
fechaSalida
		^ fechaSalida
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:46'!
fechaSalida: anObject
	fechaSalida := anObject! !

!Vuelo methodsFor: 'initialization' stamp: 'LeandroGomez 7/6/2012 13:34'!
initialize 
	self estado: EsperaDespegue new.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/6/2012 13:49'!
liberar: nro
	"Libera el asiento numero nro"
	(nro <= self asientos size) & (nro >= 0)
	ifTrue: [self estado liberar: nro vuelo: self]
	ifFalse: [ self error: 'El asiento no existe']
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen
	^ origen! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen: anObject
	origen := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/6/2012 14:42'!
pasajeroDelAsiento: nroAsiento
	"Devuelve la persona que esta en el asiento nro nroAsiento. Si no hay pasajero, manda una excepcion"
	| asiento |   
	(asiento := (self asientos detect: [ :asientoBis | asientoBis numero = nroAsiento] 
			ifNone: [ self error: 'No hay pasajero en ese asiento' ])) == nil
					ifTrue: [self error: 'Asiento Vacio']
					ifFalse: [ ^asiento persona ]! !

!Vuelo methodsFor: 'printing' stamp: 'LeandroGomez 7/1/2012 21:53'!
printOn: aStream
	"Imprime el origen, el destino final, la fecha de despegue y su estado"
	aStream nextPutAll: 'Vuelo desde: ', self origen, ' hasta ', self destinoFinal , 
						'. fecha de despegue: ', self fechaSalida asString, ' ', self estado.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/6/2012 13:36'!
reprogramar: unaFecha 
	"reprograma la fecha de despegue del vuelo a fehca unaFecha, con el mismo avion"
	self estado reprogramar: unaFecha avion: self avion vuelo: self.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 7/6/2012 13:36'!
reprogramar: unaFecha avion: unAvion
	"Reprograma el vuelo a fecha unaFecha y a un avion unAvion. 
		El avion debe tener la misma cantidad de asientos que el actual"
	self estado reprogramar: unaFecha avion: unAvion vuelo: self! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 7/1/2012 21:59'!
viaja: unaPersona
	"Devuelve true si la persona unaPersona viaja en el vuelo"
	^self asientos anySatisfy: [ :asiento | asiento persona == unaPersona ].! !
